<?php
namespace Modules\Cadastros\Controllers; 

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification;

class Cmp01200CompradorExportacaoController extends \Teknisa\GER\Controllers\TeknisaCrud {
    
    protected $dataSourceName = "cmp01200_exportacao";
    
    public function __construct($crudService, ParameterBag $parameterBag, $connection) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->con = $connection;
    }
    
    public function exportacaoDeProdutos(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $sql = "INSERT INTO PRODCOMP(CDOPERADOR, CDPRODUTO) SELECT COMPRADOR.CDOPERADOR, PRODCOMP.CDPRODUTO FROM PRODCOMP, COMPRADOR, PRODUTO WHERE PRODCOMP.CDPRODUTO = PRODUTO.CDPRODUTO AND PRODCOMP.CDOPERADOR = :P_CDOPERORG AND (INSTR(:P_CDOPERDES, COMPRADOR.CDOPERADOR) <> 0 OR :P_TCDOPERDES = 'T') AND (INSTR(:P_CDPROD, PRODUTO.CDARVPROD) <> 0 OR :P_TCDPROD = 'T') AND NOT EXISTS (SELECT A.CDPRODUTO FROM PRODCOMP A, PRODUTO B WHERE A.CDPRODUTO = B.CDPRODUTO AND A.CDOPERADOR = COMPRADOR.CDOPERADOR AND (PRODUTO.CDARVPROD LIKE B.CDARVPROD || '%' OR B.CDARVPROD LIKE PRODUTO.CDARVPROD || '%'))";
        $params = array();      //inicializa params como um array
        $params['P_CDOPERDES'] = $row['CDCOMPDEST'];
        $params['P_TCDOPERDES'] = $row['ALLCOMPDEST'];
        $params['P_CDPROD'] = $row['PRODUTOSCONCAT'];
        $params['P_TCDPROD'] = $row['ALLPRODUTO'];
        $params['P_CDOPERORG'] = $row['CDOPERADORORI'];
        
        $stmt = $this->con->prepare($sql); //preparando a conexão
        $stmt->execute($params);
    }
   
    public function exportacaoDeOperadorRelacionado(DTO\Request $request, DTO\Response $response) {
        $row = $request->getDataSet()->getRows();
        
        $selectOperadoresRelacionados = "SELECT COUNT(C.CDOPERADOR) AS QTDOPERADORES FROM COMPROPER C, COMPRADOR, OPERADOR WHERE C.CDOPERADOR = OPERADOR.CDOPERADOR AND C.CDCOMPRADOR =:P_CDCOMPORIG AND( INSTR(:P_CDOPERDES,COMPRADOR.CDOPERADOR) <> 0 OR :P_TCDOPERDES = 'T') AND ( INSTR(:P_CDOPERRELAC,OPERADOR.CDOPERADOR) <> 0 OR :P_TCDOPERRELAC = 'T' ) AND NOT EXISTS ( SELECT '1' FROM COMPROPER A WHERE A.CDOPERADOR = C.CDOPERADOR AND A.CDCOMPRADOR = COMPRADOR.CDOPERADOR )";
        
        $params = array();
        
        $params['P_CDOPERDES'] = $row[0]['CDCOMPDEST'];
        $params['P_TCDOPERDES'] = $row[0]['ALLCOMPDEST'];
        $params['P_CDOPERRELAC'] = $row[0]['CDOPERADORREL'];
        $params['P_TCDOPERRELAC'] = $row[0]['ALLOPERADORREL'];    
        $params['P_CDCOMPORIG'] = $row[0]['CDOPERADORORI'];
        
        try{
            
            $stmt = $this->con->prepare($selectOperadoresRelacionados);
            $stmt->execute($params);
            $retorno = $stmt->fetchAll();
            
        } catch(Exception $e){
            throw $e;
        }

        if($retorno[0]["QTDOPERADORES"] > 0){
            
            if($row[0]['EXCLUIR'] === "S") {
                $sqlDelete = "DELETE FROM COMPROPER WHERE (INSTR(:P_CDOPERDES, COMPROPER.CDCOMPRADOR) <> 0 OR :P_TCDOPERDES = 'T') AND (INSTR(:P_CDOPERRELAC, COMPROPER.CDOPERADOR) <> 0 OR :P_TCDOPERRELAC = 'T') AND COMPROPER.CDCOMPRADOR <> :P_CDCOMPORIG";
                $stmt = $this->con->prepare($sqlDelete); //preparando a conexão
                $params = array();
              
                $params['P_CDOPERDES'] = $row[0]['CDCOMPDEST'];
                $params['P_TCDOPERDES'] = $row[0]['ALLCOMPDEST'];
                $params['P_CDOPERRELAC'] =  $row[0]['CDOPERADORREL'];;
                $params['P_TCDOPERRELAC'] =  $row[0]['ALLOPERADORREL'];
                $params['P_CDCOMPORIG'] = $row[0]['CDOPERADORORI'];
              
                $stmt->execute($params);
            }
            
            $sql = "INSERT INTO COMPROPER (CDOPERADOR, CDCOMPRADOR, IDEXSENHCMPOPER, IDCOTCMPOPER, IDAPURCMPOPER, IDAFCMPOPER) SELECT C.CDOPERADOR, COMPRADOR.CDOPERADOR, C.IDEXSENHCMPOPER, C.IDCOTCMPOPER, C.IDAPURCMPOPER, C.IDAFCMPOPER FROM COMPROPER C, COMPRADOR, OPERADOR WHERE C.CDOPERADOR = OPERADOR.CDOPERADOR AND C.CDCOMPRADOR = :P_CDCOMPORIG AND (INSTR(:P_CDOPERDES, COMPRADOR.CDOPERADOR) <> 0 OR :P_TCDOPERDES = 'T') AND (INSTR(:P_CDOPERRELAC, OPERADOR.CDOPERADOR) <> 0 OR :P_TCDOPERRELAC = 'T') AND NOT EXISTS (SELECT '1' FROM COMPROPER A WHERE A.CDOPERADOR = C.CDOPERADOR AND A.CDCOMPRADOR = COMPRADOR.CDOPERADOR)";
            
            $stmt = $this->con->prepare($sql); //preparando a conexão
            $stmt->execute($params);
            
        } else {
            $response->addDataSet(new DataSet("OPERADORES_NAO_ENCONTRADOS", array(true)));
        }
    }
}

