<?php

require_once 'base/ComunicaparcEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 *
 * @package Entity
 *
 * @author  gustavo
 */
class ComunicaparcEntity extends ComunicaparcEntityBase
{

    public function incluiComunicacaoParcTkDb(
        $nrOrg, $nrParcNegocio, $nrEnderecoParc, $cdFormaComu, $cdComunicaParc, $idAtivo, $dtInclusao
    ){
        return Comunicaparc::incluiComunicacaoParcTkDb(
            $nrOrg, $nrParcNegocio, $nrEnderecoParc, $cdFormaComu, $cdComunicaParc, $idAtivo, $dtInclusao
        );
    }


    /**
     * Inclui uma nova comunicacao do parceiro.
     *
     * @param integer $nrParcNegocio  Numero de Parceiro de Negocio.
     * @param integer $nrEnderecoParc Numero de Endereco do Parceiro.
     * @param string  $cdFormaComu    Codigo de Forma de Comunicacao.
     * @param string  $cdComunicaParc Codigo de Comunicacao de Parceiro.
     * @param string  $idAtivo        Id Ativo.
     * @param integer $nrOrg          Numero de Organizao.
     *
     * @author talitaorfano - 05/09/2011
     */
    public function incluiComunicacaoParc(
        $nrParcNegocio, $nrEnderecoParc, $cdFormaComu, $cdComunicaParc, $idAtivo, $nrOrg
    ) {
        try {
            $comunicaParc = new self();

            //$comunicaParc->setNrcomunicaparc($nrComunicaParcparc);
            $comunicaParc->setNrparcnegocio($nrParcNegocio);
            $comunicaParc->setNrenderecoparc($nrEnderecoParc);
            $comunicaParc->setCdformacomu($cdFormaComu);
            $comunicaParc->setCdcomunicaparc($cdComunicaParc);
            $comunicaParc->setIdativo($idAtivo);
            $comunicaParc->setNrorg($nrOrg);
            //$comunicaParc->setDtinclusao($dtInclusao);

            $comunicaParc->persist();

            unset($comunicaParc);
            return true;
        }
        catch (Exception $e){
            //tk_message(' Exception '.$e->getLine().' : '.$e->getTrace().' - '.$e->getMessage(), TkMessage::TYPE_ERROR);
            throw $e;
            //return false;
        }
    }


    public function retornaComunicacaoPorParceiro($nrOrg, $nrParceiro){
        $resultados = Comunicaparc::retornaComunicacaoPorParceiro($nrOrg, $nrParceiro);
        return $resultados;
    }


    /**
     * Enter description here ...
     * @param unknown_type $nrOrg
     * @param unknown_type $nrParceiro
     */
    public function carregaComunicacaoPorParceiro($nrOrg, $nrParceiro){
        $resultados = $this->retornaComunicacaoPorParceiro($nrOrg, $nrParceiro);
        foreach ($resultados as $item) {
            $this->addItem($item);
        }
    }


    public function retornaComunicaParcPorForma($nrOrg, $nrParceiro, $cdFormaComunicacao){
        $itens = $this->getItems();
        if (count($itens) === 0) {
            $this->carregaComunicacaoPorParceiro($nrOrg, $nrParceiro);
            $itens = $this->getItems();
        }

        foreach ($itens as $item) {
            if ($item->getCdformacomu() === $cdFormaComunicacao){
                return $item;
            }
        }
        return false;
    }

    public static function retornaComunicacaoPrincipalPorParceiro($nrParceiro, $nrOrg){

        $dadosComunica = Comunicaparc::retornaComunicacaoPrincipalPorParceiro($nrParceiro, $nrOrg);
        if(is_object($dadosComunica)) {
            return $dadosComunica;
        }
    }

    public function setComunicacaoParceiro($nrorg, $nrparcnegocio, $idativo, $nrenderecoparc, $cdformacomu, $cdcomunicaparc)
    {
        $this->setNrorg($nrorg);
        $this->setNrparcnegocio($nrparcnegocio);
        $this->setIdativo($idativo);
        $this->setNrenderecoparc($nrenderecoparc);
        $this->setCdformacomu($cdformacomu);
        $this->setCdcomunicaparc($cdcomunicaparc);
    }

    public static function getByNrorgParceiroCdformaDescricao($nrorg, $nrparcnegocio, $cdformacomunica, $descricao) {
        $comunicaparc = self::getEntityByWhere('NRORG, NRPARCNEGOCIO, CDFORMACOMUNICA, DESCRICAO');
        return $comunicaparc;
    }

    public static function validaComunicacaoParceiro($cdcomunicaparc, $nrOrg) {
        $comunicaparc = Comunicaparc::validaCdComunicaParc($cdcomunicaparc, $nrOrg);
        if (is_object($comunicaparc)){
            return true;
        } else {
            return false;
        }
    }

    public static function findByNrorgParceiroCdformacomu($nrorg, $nrparcnegocio, $cdformacomunica) {
        $comunicaparc = self::getEntityByWhere(
            'NRORG = ? AND NRPARCNEGOCIO = ? AND CDFORMACOMU = ?', array($nrorg, $nrparcnegocio, $cdformacomunica)
        );
        return $comunicaparc;
    }

}
















