CREATE OR REPLACE PROCEDURE CONTABILIZAR(
  P_NRLISTA IN LISTA.NRLISTA%TYPE,
  P_TIPOMOVI IN VARCHAR)
IS
  V_NRLISTA VARCHAR(10);
BEGIN 
   CASE P_TIPOMOVI
     WHEN '00' THEN /* NOTA FISCAL ENTRADA*/
        BEGIN
           CONTABILIZA_NF_ENTRADA(P_NRLISTA);
        END;
     WHEN '01' THEN /* NF SAIDA*/
        BEGIN
           CONTABILIZA_NF_SAIDA(P_NRLISTA);
        END;
     WHEN '02' THEN /* RETIRADA ESTOQUE */
        BEGIN
           CONTABILIZA_RET_ESTOQUE(P_NRLISTA);
        END;
     WHEN '03' THEN       /* RETIRADA PRODUCAO*/
        BEGIN
           CONTABILIZA_RET_PROD(P_NRLISTA);
        END;       
     WHEN '04' THEN /* SAIDA ESTOQUE */
        BEGIN
           CONTABILIZA_EST_SAIDA(P_NRLISTA);
        END;     
     WHEN '05' THEN /* AJUSTE E IMPLANTACAO*/
        BEGIN
           CONTABILIZA_EST_AJUIMPL(P_NRLISTA);
        END;         
     WHEN '06' THEN /* CONTAS A PAGAR*/
        BEGIN
           CONTABILIZA_PAG_CONTA(P_NRLISTA);
        END;
     WHEN '07' THEN /* CONTAS A RECEBER*/
        BEGIN
           CONTABILIZA_REC_CONTA(P_NRLISTA);
        END;      
     WHEN '08' THEN /* BCO LANCCORR*/
        BEGIN
           CONTABILIZA_BCO_LANCCORR(P_NRLISTA);
        END;
     WHEN '09' THEN /* BCO TRANSFERENCIA*/
        BEGIN
           CONTABILIZA_BCO_TRANSCORR(P_NRLISTA);
        END;     
     WHEN '10' THEN /* BAIXA PAGAR*/
        BEGIN
           CONTABILIZA_PAG_BAIXA(P_NRLISTA);
        END;   
     WHEN '11' THEN /* BAIXA RECEBER*/
        BEGIN
           CONTABILIZA_REC_BAIXA(P_NRLISTA);
        END;
   END CASE;     
END ;
/