/* Tabela FILIOPER: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes
na tabela FILIOPER */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela FILIOPER
utilizando a tabela Geral de Logs de Operaes */

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GER_FILIOPER' AND
                 TYPE   = 'TR' 		         AND
	              U.UID  = O.UID              AND
	              U.NAME = USER)
DROP TRIGGER LOG_GER_FILIOPER
GO


CREATE TRIGGER LOG_GER_FILIOPER
ON FILIOPER
FOR INSERT, UPDATE, DELETE
AS

   DECLARE  @V_USUARIO        VARCHAR(40);
   DECLARE  @V_TIPO           VARCHAR(1);
   DECLARE  @V_ITPESQ         VARCHAR(40);
   DECLARE  @V_DESC           VARCHAR(300);
   DECLARE  @V_DTOPER         DATETIME;
/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO     VARCHAR(1);
   DECLARE  @V_OLD_CDOPERADOR VARCHAR(12);
   DECLARE  @V_OLD_CDFILIAL   VARCHAR(4);
   DECLARE  @V_NEW_CDOPERADOR VARCHAR(12);
   DECLARE  @V_NEW_CDFILIAL   VARCHAR(4);


BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';


   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
     'D' IDCOMANDO,
         CDOPERADOR,
         CDFILIAL,
         NULL,
         NULL
   FROM
      DELETED
   WHERE
      CDOPERADOR+CDFILIAL NOT IN (SELECT CDOPERADOR+CDFILIAL FROM INSERTED)
   UNION ALL

   SELECT
     'U' IDCOMANDO,
         DELETED.CDFILIAL,
         DELETED.CDOPERADOR,
         INSERTED.CDFILIAL,
         INSERTED.CDOPERADOR
   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.CDOPERADOR = DELETED.CDOPERADOR   AND
      INSERTED.CDFILIAL   = DELETED.CDFILIAL
   UNION ALL
   SELECT
      'I'IDCOMANDO,
         NULL,
         NULL,
         CDOPERADOR,
         CDFILIAL
   FROM
      INSERTED
   WHERE
      CDOPERADOR+CDFILIAL NOT IN (SELECT CDOPERADOR+CDFILIAL FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_OLD_CDOPERADOR,
                                 @V_OLD_CDFILIAL,
                                 @V_NEW_CDOPERADOR,
                                 @V_NEW_CDFILIAL;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN
         SET @V_TIPO         = '3';
         SET @V_ITPESQ       = @V_OLD_CDOPERADOR+@V_OLD_CDFILIAL;
         IF @V_OLD_CDFILIAL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Cod=' + @V_OLD_CDFILIAL;
         END;
      END
      ELSE
         IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
            IF (@V_OLD_CDFILIAL <> @V_NEW_CDFILIAL) BEGIN
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_CDOPERADOR+@V_OLD_CDFILIAL;
            END;
         END
         ELSE BEGIN
            SET @V_TIPO         = '1';
            SET @V_ITPESQ       = @V_NEW_CDOPERADOR+@V_NEW_CDFILIAL;
         END;
      IF @V_NEW_CDFILIAL IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + 'Cod=' + @V_NEW_CDFILIAL;
      END;

      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('FILIOPER',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO,      @V_ITPESQ, @V_DESC);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_OLD_CDOPERADOR,
                                    @V_OLD_CDFILIAL,
                                    @V_NEW_CDOPERADOR,
                                    @V_NEW_CDFILIAL;
   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_GER_FILIOPER','4.11.105';





